/*******************************************************************************
 * FluidSurfaceComponent generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FluidSurfaceComponent extends PrimitiveComponent
    native(Fluid)
    editinlinenew
    hidecategories(Object)
    autoexpandcategories(FluidSurfaceComponent,Fluid,FluidDetail);

var() MaterialInterface FluidMaterial;
var(Lighting) int LightMapResolution;
var(Lightmass) LightmassPrimitiveSettings LightmassSettings;
var(Fluid) bool EnableSimulation;
var(Fluid) bool EnableDetail;
var(FluidDetail) bool bTiling;
var(FluidDebug) transient bool bPause;
var(FluidDebug) transient bool bShowSimulationNormals;
var(FluidDebug) bool bShowSimulationPosition;
var(FluidDebug) bool bShowDetailNormals;
var(FluidDebug) bool bShowDetailPosition;
var(FluidDebug) transient bool bShowFluidSimulation;
var(FluidDebug) transient bool bShowFluidDetail;
var(FluidDebug) bool bTestRipple;
var(FluidDebug) bool bTestRippleCenterOnDetail;
var(Fluid) int SimulationQuadsX;
var(Fluid) int SimulationQuadsY;
var(Fluid) float GridSpacing;
var(Fluid) float GridSpacingLowRes;
var(Fluid) Actor TargetSimulation;
var(Fluid) float GPUTessellationFactor;
var(Fluid) float FluidDamping;
var(Fluid) float FluidTravelSpeed;
var(Fluid) float FluidHeightScale;
var(Fluid) float FluidUpdateRate;
var(Fluid) float ForceImpact;
var(Fluid) float ForceContinuous;
var(Fluid) float LightingContrast;
var(Fluid) Actor TargetDetail;
var(Fluid) float DeactivationDistance;
var(FluidDetail) int DetailResolution;
var(FluidDetail) float DetailSize;
var(FluidDetail) float DetailDamping;
var(FluidDetail) float DetailTravelSpeed;
var(FluidDetail) float DetailTransfer;
var(FluidDetail) float DetailHeightScale;
var(FluidDetail) float DetailUpdateRate;
var(FluidDebug) float NormalLength;
var(FluidDebug) float TestRippleSpeed;
var(FluidDebug) float TestRippleFrequency;
var(FluidDebug) float TestRippleRadius;
var private float FluidWidth;
var private float FluidHeight;
var private native transient float TestRippleTime;
var private native transient float TestRippleAngle;
var private native transient float DeactivationTimer;
var private native transient float ViewDistance;
var private native transient Vector SimulationPosition;
var private native transient Vector DetailPosition;
var const array<byte> ClampMap;
var private const array<ShadowMap2D> ShadowMaps;
var private native const LightMapRef LightMap;
var private native const transient Pointer FluidSimulation;

// Export UFluidSurfaceComponent::execApplyForce(FFrame&, void* const)
native final function ApplyForce(Vector WorldPos, float Strength, float Radius, optional bool bImpulse);

// Export UFluidSurfaceComponent::execSetDetailPosition(FFrame&, void* const)
native final function SetDetailPosition(Vector WorldPos);

// Export UFluidSurfaceComponent::execSetSimulationPosition(FFrame&, void* const)
native final function SetSimulationPosition(Vector WorldPos);

defaultproperties
{
    LightMapResolution=128
    LightmassSettings=(bUseTwoSidedLighting=false,bShadowIndirectOnly=false,bUseEmissiveForStaticLighting=false,EmissiveLightFalloffExponent=2.0,EmissiveLightExplicitInfluenceRadius=0.0,EmissiveBoost=1.0,DiffuseBoost=1.0,SpecularBoost=1.0,FullyOccludedSamplesFraction=1.0)
    EnableSimulation=true
    EnableDetail=true
    bShowFluidSimulation=true
    bShowFluidDetail=true
    SimulationQuadsX=200
    SimulationQuadsY=200
    GridSpacing=10.0
    GridSpacingLowRes=800.0
    GPUTessellationFactor=1.0
    FluidDamping=1.0
    FluidTravelSpeed=1.0
    FluidHeightScale=1.0
    FluidUpdateRate=30.0
    ForceImpact=-3.0
    ForceContinuous=-200.0
    LightingContrast=1.0
    DeactivationDistance=3000.0
    DetailResolution=256
    DetailSize=500.0
    DetailDamping=1.0
    DetailTravelSpeed=1.0
    DetailTransfer=0.50
    DetailHeightScale=1.0
    DetailUpdateRate=30.0
    NormalLength=10.0
    TestRippleSpeed=1.0
    TestRippleFrequency=1.0
    TestRippleRadius=30.0
    FluidWidth=2000.0
    FluidHeight=2000.0
    ReplacementPrimitive=none
    bIgnoreNearPlaneIntersection=true
    bForceDirectLightMap=true
    bAcceptsLights=true
    bUsePrecomputedShadows=true
    CollideActors=true
    BlockZeroExtent=true
    BlockNonZeroExtent=true
    bTickInEditor=true
}